import es, os.path, popuplib, cPickle

player_database = {}

def dndMsg(msg):
    es.msg('#multi', '#darkgreen', '[D&D]', '#default', msg)
    
def dndTell(userid, msg=[]):
    es.tell(userid, '#multi', '#darkgreen', '[D&D]', '#default', msg)

def unload():
    saveDatabase()

def load():
    try:
        loadDatabase()
    except:
        dndMsg('Failed to load database')

    global main_menu, race_menu, normal_races, la_races

    main_menu = popuplib.create('main_menu')
    main_menu.addline('Dungeons and Dragons CSS Main Menu:')
    main_menu.addline('-> 1. Race')
    main_menu.addline('-> 2. Class')
    main_menu.addline('-> 3. Prestige')
    #main_menu.addline('-> 4. Info Menu') # Will probably just give info for races at selection
    main_menu.addline('-> 5. Class Weapon List')
    main_menu.addline('-> 6. Stats')
    main_menu.submenu(1, 'race_menu')
    main_menu.submenu(2, 'class_menu')
    main_menu.menuSelect = mainSelect

    race_menu = popuplib.create('race_menu')
    race_menu.addline('Please choose what type of race you wish to be:')
    race_menu.addline('-> 1. Normal Races')
    race_menu.addline('-> 2. Level Adjustment Races')
    race_menu.addline('-> 9. Back To Main Menu')
    race_menu.addline('0. Exit')
    race_menu.submenu(1, 'normal_races')
    race_menu.submenu(2, 'la_races')
    race_menu.submenu(9, 'main_menu')
    
    normal_races = popuplib.create('normal_races')
    normal_races.addline('Dungeons and Dragons CSS Races:')
    normal_races.addline('-> 1. Human')
    normal_races.addline('-> 2. Dwarf')
    normal_races.addline('-> 3. Elf')
    normal_races.addline('-> 4. Orc')
    normal_races.addline('-> 5. Halfling')
    normal_races.addline('-> 6. Kobold')
    normal_races.addline('-> 7. Grey Elf')
    normal_races.addline('-> 9. Back To Races Menu')
    normal_races.addline('0. Exit')
    normal_races.submenu(9, 'races_menu')
    normal_races.menuSelect = normalRaceSelect
    
    la_races = popuplib.create('la_races')
    la_races.addline('Dungeons and Dragons CSS Level-Adjustment Races:')
    la_races.addline('-> 9. Back To Races Menu')
    la_races.addline('0. Exit')
    la_races.submenu(9, 'races_menu')
    la_races.menuSelect = laRaceSelect
    
    class_menu = popuplib.create('class_menu')
    class_menu.addline('Dungeons and Dragons CSS Classes:')
    class_menu.addline('-> 1. Fighter')
    class_menu.addline('-> 2. Cleric')
    class_menu.addline('-> 3. Rogue')
    class_menu.addline('-> 4. Sorceror')
    class_menu.addline('-> 9. Back To Main Menu')
    class_menu.addline('0. Exit')
    class_menu.submenu(9, 'main_menu')
    class_menu.menuselect = classSelect
    
    
def loadDatabase():
    global player_database
    str_path = es.getAddonPath('dnd') + '/player_database.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        player_database = cPickle.load(file_users)
        file_users.close()
        
def saveDatabase():
    str_path = open(es.getAddonPath('dnd') + '/player_database.db', 'w')
    cPickle.dump(player_database, str_path)
    str_path.close()
    
def player_activate(ev):
    player = es.getplayersteamid(ev['userid'])
    if player not in player_database:
        player_database[player] = {
                                    'class'     :'Fighter',
                                    'race'      :'Human',
                                    'la'        :0,
                                    'prestige'  :0,
                                    'Fighter'   : 
                                                    {
                                                        'level' :1,
                                                        'xp'    :0
                                                    },
                                    'Delayed'   :
                                                    {
                                                        'class':None,
                                                        'race':None,
                                                        'prestige':None
                                                    }
                                }
                                    
def mainSelect(userid, choice, popupid):
    pass
    
def normalRaceSelect(userid, choice, popupid):
    pass
    
def classSelect(userid, choice, popupid):
    pass

def laRaceSelect(userid, choice, popupid):
    pass 